gtkmm: Gtk::EventBox Class Reference

gtkmm 2.24.4

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions

# Gtk::EventBox Class Reference
Widgets

Event capturing box. More...

Inheritance diagram for Gtk::EventBox:
[legend]
Collaboration diagram for Gtk::EventBox:
[legend]

List of all members.

## Public Member Functions
virtual | ~EventBox ()
GtkEventBox* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkEventBox* | gobj () const
| Provides access to the underlying C GtkObject.
| EventBox ()
bool | get_visible_window () const
| Returns whether the event box has a visible window.
void | set_visible_window (bool visible_window=true)
| Set whether the event box uses a visible or invisible child window.
bool | get_above_child () const
| Returns whether the event box window is above or below the windows of its child.
void | set_above_child (bool above_child=true)
| Set whether the event box window is positioned above the windows of its child, as opposed to below it.
Glib::PropertyProxy< bool > | property_visible_window ()
| Whether the event box is visible, as opposed to invisible and only used to trap events.
Glib::PropertyProxy_ReadOnly < bool > | property_visible_window () const
| Whether the event box is visible, as opposed to invisible and only used to trap events.
Glib::PropertyProxy< bool > | property_above_child ()
| Whether the event-trapping window of the eventbox is above the window of the child widget as opposed to below it.
Glib::PropertyProxy_ReadOnly < bool > | property_above_child () const
| Whether the event-trapping window of the eventbox is above the window of the child widget as opposed to below it.
## Related Functions
(Note that these are not member functions.)
Gtk::EventBox* | wrap (GtkEventBox* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Event capturing box.

This widget adds an X Window where one does not normally appear, allowing you to capture events. It will receive any event which is specified with set_events().

This widget is generally used to add Gtk::Tooltips, button presses, and clipping to widgets derived from Gtk::Misc.

## Constructor & Destructor Documentation

virtual Gtk::EventBox::~EventBox | ( |  | ) | `[virtual]`

Gtk::EventBox::EventBox | ( |  | ) |

## Member Function Documentation

bool Gtk::EventBox::get_above_child | ( |  | ) | const

Returns whether the event box window is above or below the windows of its child.

See set_above_child() for details.

Since gtkmm 2.4:

Returns:
  `true` if the event box window is above the window of its child.

bool Gtk::EventBox::get_visible_window | ( |  | ) | const

Returns whether the event box has a visible window.

See set_visible_window() for details.

Since gtkmm 2.4:

Returns:
  `true` if the event box window is visible.

const GtkEventBox* Gtk::EventBox::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Bin.

GtkEventBox* Gtk::EventBox::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Bin.

Glib::PropertyProxy<bool> Gtk::EventBox::property_above_child | ( |  | ) |

Whether the event-trapping window of the eventbox is above the window of the child widget as opposed to below it.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::EventBox::property_above_child | ( |  | ) | const

Whether the event-trapping window of the eventbox is above the window of the child widget as opposed to below it.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly<bool> Gtk::EventBox::property_visible_window | ( |  | ) | const

Whether the event box is visible, as opposed to invisible and only used to trap events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

Glib::PropertyProxy<bool> Gtk::EventBox::property_visible_window | ( |  | ) |

Whether the event box is visible, as opposed to invisible and only used to trap events.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns:
  A PropertyProxy that allows you to get or set the property of the value, or receive notification when the value of the property changes.

void Gtk::EventBox::set_above_child | ( | bool | above_child = `true` | ) |

Set whether the event box window is positioned above the windows of its child, as opposed to below it.

If the window is above, all events inside the event box will go to the event box. If the window is below, events in windows of child widgets will first got to that widget, and then to its parents.

The default is to keep the window below the child.

Since gtkmm 2.4:

Parameters:

  above_child | `true` if the event box window is above the windows of its child.

void Gtk::EventBox::set_visible_window | ( | bool | visible_window = `true` | ) |

Set whether the event box uses a visible or invisible child window.

The default is to use visible windows.

In an invisible window event box, the window that the event box creates is a Gdk::INPUT_ONLY window, which means that it is invisible and only serves to receive events.

A visible window event box creates a visible (Gdk::INPUT_OUTPUT) window that acts as the parent window for all the widgets contained in the event box.

You should generally make your event box invisible if you just want to trap events. Creating a visible window may cause artifacts that are visible to the user, especially if the user is using a theme with gradients or pixmaps.

The main reason to create a non input-only event box is if you want to set the background to a different color or draw on it.

<note> There is one unexpected issue for an invisible event box that has its window below the child. (See set_above_child().) Since the input-only window is not an ancestor window of any windows that descendent widgets of the event box create, events on these windows aren't propagated up by the windowing system, but only by GTK+. The practical effect of this is if an event isn't in the event mask for the descendant window (see Gtk::Widget::add_events()), it won't be received by the event box.

This problem doesn't occur for visible event boxes, because in that case, the event box window is actually the ancestor of the descendant windows, not just at the same place on the screen. </note>

Since gtkmm 2.4:

Parameters:

  visible_window | Boolean value.

## Friends And Related Function Documentation

Gtk::EventBox* wrap | ( | GtkEventBox * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/eventbox.h